<?php

namespace App\Services\Cartables\RoadPatrol;

use App\Exceptions\ProhibitedAction;
use App\Facades\DataTable\DataTableFacade;
use App\Models\RoadPatrol;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Throwable;

class SupervisorService
{
    /**
     * @throws Throwable
     */
    public function dataTable(Request $request, $loadRelations = false)
    {
        $user = auth()->user();
        $query = null;

        if ($user->hasPermissionTo('show-road-patrol-supervise-cartable')) {
            $query = RoadPatrol::query()
                ->when($loadRelations, fn ($query) => $query->with(['rahdaran:id,name,code', 'cmmsMachines:id,machine_code,car_name,plak_number']));
        }
        elseif ($user->hasPermissionTo('show-road-patrol-supervise-cartable-province'))
        {
            throw_if(is_null($user->province_id), new ProhibitedAction('استانی برای شما در سامانه ثبت نشده است!'));

            $query = RoadPatrol::query()
                ->where('province_id', '=', $user->province_id)
                ->when($loadRelations, fn ($query) => $query->with(['rahdaran:id,name,code', 'cmmsMachines:id,machine_code,car_name,plak_number']));
        }

        return DataTableFacade::run(
            $query,
            $request,
            allowedFilters: ['*'],
            allowedSortings: ['*'],
            allowedSelects: [
                'province_fa', 'province_id', 'id', 'edare_id', 'edare_name',
                'start_time', 'end_time', 'created_at', 'description',
                'distance', 'vehicle_runtime', 'fuel_consumption', 'stop_points'
            ]
        );
    }
}